import { RequestMethod, ResponseContentType, Response, Headers } from '@angular/http';
export declare abstract class RestApi {
    abstract get(uri: string, params?: any, headers?: Headers, responseType?: ResponseContentType): Promise<any>;
    abstract put(uri: string, body?: any, params?: any): any;
    abstract post(uri: string, body?: any, params?: any): Promise<any>;
    abstract delete(uri: string, body?: any): Promise<any>;
    abstract patch(uri: string, body: any): Promise<any>;
    abstract prepareUri(...parts: string[]): string;
    abstract send(config: RequestConfiguration): Promise<Response>;
}
export interface RequestConfiguration {
    method: RequestMethod;
    path: string;
    body?: any;
    headers?: Headers;
    params?: any;
    responseType?: number;
    skipErrorHandling?: boolean;
}
