import { OnInit, EventEmitter } from '@angular/core';
import { Observable } from 'rxjs/';
import { DataSource } from '@angular/cdk/collections';
import { MatPaginator } from '@angular/material';
import { MatDialog } from '@angular/material';
import { FieldConfig } from './field.config';
import { DataServiceApi } from '../services/data-service-api';
import { MatSort } from '@angular/material';
export declare class UniversalTableComponent implements OnInit {
    private _dialog;
    actions: any[];
    columns: any;
    displayedColumns: any[];
    filterFields: any[];
    fieldsDescriptions: any[];
    selectableColumn: any;
    filterPanel: boolean;
    addButton: boolean;
    previewObject: any;
    itemsService: DataServiceApi;
    fieldsConfig: Map<string, FieldConfig>;
    paginator: MatPaginator;
    sort: MatSort;
    dataSource: ItemsDataSource;
    filters: EventEmitter<any>;
    filtersChange: FiltersWrapper;
    checkedItem: any[];
    itemsCount: number;
    onPreview: EventEmitter<any>;
    onDownload: EventEmitter<any>;
    onAdd: EventEmitter<any>;
    onEdit: EventEmitter<any>;
    onDelete: EventEmitter<any>;
    onAddInRow: EventEmitter<any>;
    modificationCheckedItems: EventEmitter<any>;
    tableChangeEvent: EventEmitter<any>;
    private item;
    constructor(_dialog: MatDialog);
    ngOnInit(): void;
    addRow(): void;
    onFiltersChange(event: any): void;
    onPreviewEvent(event: any): void;
    onEditEvent(event: any): void;
    onDeleteEvent(event: any): void;
    onDownloadEvent(event: any): void;
    /** invoke something action if row is clicked */
    handleRowClick(row: any): void;
    /** check item from checkBox and add item to checkedItem array  */
    checkItem(checkbox: any, row: any): void;
    onAddInRowEvent(event: any): void;
}
export declare class ItemsDataSource extends DataSource<any> {
    private itemsService;
    private _paginator;
    private _filters;
    private filtersChange;
    private _tableChangeEvent;
    private _sort;
    private _selectableColumn;
    private _modificationSelectedItems;
    items: any[];
    checkedItem: any[];
    constructor(itemsService: DataServiceApi, _paginator: MatPaginator, _filters: EventEmitter<any>, filtersChange: FiltersWrapper, _tableChangeEvent: EventEmitter<any>, _sort: MatSort, _selectableColumn?: boolean, _modificationSelectedItems?: EventEmitter<any>);
    /** Connect function called by the table to retrieve one stream containing the data to render. */
    connect(): Observable<any[]>;
    rewriteSelection(checkedItem: any): void;
    disconnect(): void;
    private prepareSortParam();
    private prepareFilterParams(filters);
}
export declare class FiltersWrapper {
    filters: any;
}
