import { RestApi, RequestConfiguration } from '../modules/permissions/models/config/rest-api';
import { Headers, Http, Response, ResponseContentType } from '@angular/http';
import { HttpSessionService } from './http-session.service';
import { CommonApiErrorHandlerService } from './common-api-error-handler.service';
import 'rxjs/add/operator/toPromise';
export declare class RestApiService extends RestApi {
    private _http;
    private _session;
    private _handler;
    private _baseUri;
    constructor(_http: Http, _session: HttpSessionService, _handler: CommonApiErrorHandlerService);
    get(uri: string, params?: any, headers?: Headers, responseType?: ResponseContentType): Promise<any>;
    put(uri: string, body?: any, params?: any): Promise<any>;
    post(uri: string, body?: any, params?: any): Promise<any>;
    delete(uri: string, body?: any): Promise<any>;
    patch(uri: string, body: any): Promise<any>;
    prepareUri(...parts: string[]): string;
    send(config: RequestConfiguration): Promise<Response>;
    private _sendRequest(config);
    private _prepareUrl(path);
}
